using System;
using SdlDotNet;

namespace PatrullaAguila
{
	/// <summary>
	/// Descripcin breve de EventManager.
	/// </summary>
	public class EventManager
	{
		public EventManager()
		{
		}

		public delegate void EntityMoveRequestEventHandler(object sender, EntityMoveRequestEventArgs e);
		public event EntityMoveRequestEventHandler OnEntityMoveRequestEvent;

		public event QuitEventHandler OnQuitEvent;

		public void Publish(Object obj)
		{
			if (obj.GetType().Name == "QuitEventArgs")
			{
				if (OnQuitEvent != null) 
				{
					//LogFile.WriteLine("EventManager has received Quit event");
					OnQuitEvent(this, (SdlDotNet.QuitEventArgs) obj);
				}
			}
			else if (obj.GetType().Name == "EntityMoveRequestEventArgs")
			{
				OnEntityMoveRequestEvent(this, (EntityMoveRequestEventArgs) obj);
			}
		}

	}
}
