using System;
using System.IO;

namespace PatrullaAguila
{
	public struct TipusCoordenada 
	{
		public int x, y;
	}

	public enum TipusFormacio 
	{
		Cunya = 0,
		Ascua,
		Fletxa,
		SuperMirlo,
		Mirlo,
		Poker,
		Inici,
		Fi
	}

	/// <summary>
	/// Descripcin breve de Formacio.
	/// </summary>
	public class Formacio
	{
		private TipusCoordenada[] formacioCunya = new TipusCoordenada[7];	// 7 avions
		private TipusCoordenada[] formacioAscua = new TipusCoordenada[7];
		private TipusCoordenada[] formacioFletxa = new TipusCoordenada[7];
		private TipusCoordenada[] formacioSuperMirlo = new TipusCoordenada[7];
		private TipusCoordenada[] formacioMirlo = new TipusCoordenada[7];
		private TipusCoordenada[] formacioPoker = new TipusCoordenada[7];

		public Formacio()
		{
		}

		public bool inicialitzarFormacions(string fitxer) 
		{
			bool correcte = false;
			string linia;
			try 
			{
				using (StreamReader sr = new StreamReader(fitxer)) 
				{
					linia = sr.ReadLine();
					linia = sr.ReadLine();
					for(int i = 0; i < 7; i++) {
						formacioCunya[i].x = linia[0] - 48;
						formacioCunya[i].y = linia[2] - 48;
						linia = sr.ReadLine();
					}
					linia = sr.ReadLine();
					for(int i = 0; i < 7; i++) 
					{
						formacioAscua[i].x = linia[0] - 48;
						formacioAscua[i].y = linia[2] - 48;
						linia = sr.ReadLine();
					}
					linia = sr.ReadLine();
					for(int i = 0; i < 7; i++) 
					{
						formacioFletxa[i].x = linia[0] - 48;
						formacioFletxa[i].y = linia[2] - 48;
						linia = sr.ReadLine();
					}
					linia = sr.ReadLine();
					for(int i = 0; i < 7; i++) 
					{
						formacioSuperMirlo[i].x = linia[0] - 48;
						formacioSuperMirlo[i].y = linia[2] - 48;
						linia = sr.ReadLine();
					}
					linia = sr.ReadLine();
					for(int i = 0; i < 7; i++) 
					{
						formacioMirlo[i].x = linia[0] - 48;
						formacioMirlo[i].y = linia[2] - 48;
						linia = sr.ReadLine();
					}
					linia = sr.ReadLine();
					for(int i = 0; i < 7; i++) 
					{
						formacioPoker[i].x = linia[0] - 48;
						formacioPoker[i].y = linia[2] - 48;
						linia = sr.ReadLine();
					}
					linia = sr.ReadLine();
				}
				correcte = true;
			}
			catch (Exception e) 
			{
				Console.WriteLine(e.Message);
				correcte = false;
			}

			return correcte;
		}

		public TipusCoordenada[] obtenir_posicions_formacio(TipusFormacio formacio) 
		{
			switch(formacio) 
			{
				case TipusFormacio.Cunya:
					return formacioCunya;
				case TipusFormacio.Ascua:
					return formacioAscua;
				case TipusFormacio.Fletxa:
					return formacioFletxa;
				case TipusFormacio.SuperMirlo:
					return formacioSuperMirlo;
				case TipusFormacio.Mirlo:
					return formacioMirlo;
				case TipusFormacio.Poker:
					return formacioPoker;
				default:
					return null;
			}
		}
	}
}
