using System;
using SdlDotNet;

namespace PatrullaAguila
{
	/// <summary>
	/// Descripcin breve de InputController.
	/// </summary>
	public class InputController
	{
		bool quitFlag;
		EventManager eventManager;

		public InputController(EventManager eventManager)
		{
			this.eventManager = eventManager;
			this.eventManager.OnQuitEvent += new QuitEventHandler(Subscribe);
			Events.KeyboardDown += new KeyboardEventHandler(this.KeyboardDown); 
			//Events.KeyboardUp += new KeyboardEventHandler(this.KeyboardUp); 
			Events.Quit += new QuitEventHandler(this.Quit);
		}

		private void Subscribe(object eventManager, QuitEventArgs e)
		{
			//LogFile.WriteLine("InputController received a Quit event");
			quitFlag = true;
		}

		private void KeyboardDown(object sender, KeyboardEventArgs e) 
		{
			if (e.Key == Key.Escape || e.Key == Key.Q)
			{
				eventManager.Publish(new QuitEventArgs());
			}
			else if (e.Key == Key.Keypad1)
			{
				eventManager.Publish(new EntityMoveRequestEventArgs(TipusFormacio.Cunya));
			}
			else if (e.Key == Key.Keypad2)
			{
				eventManager.Publish(new EntityMoveRequestEventArgs(TipusFormacio.Ascua));
			}
			else if (e.Key == Key.Keypad3)
			{
				eventManager.Publish(new EntityMoveRequestEventArgs(TipusFormacio.Fletxa));
			}
			else if (e.Key == Key.Keypad4)
			{
				eventManager.Publish(new EntityMoveRequestEventArgs(TipusFormacio.SuperMirlo));
			}
			else if (e.Key == Key.Keypad5)
			{
				eventManager.Publish(new EntityMoveRequestEventArgs(TipusFormacio.Mirlo));
			}
			else if (e.Key == Key.Keypad6)
			{
				eventManager.Publish(new EntityMoveRequestEventArgs(TipusFormacio.Poker));
			}
			
		}

		/*private void KeyboardUp(object sender, KeyboardEventArgs e) 
		{
			if (e.Key == Key.UpArrow)
			{
				eventManager.Publish(new EntityMoveRequestEventArgs(AccioEvent.Quiet));
			}
			else if (e.Key == Key.DownArrow)
			{
				eventManager.Publish(new EntityMoveRequestEventArgs(AccioEvent.Quiet));
			}
			else if (e.Key == Key.LeftArrow)
			{
				eventManager.Publish(new EntityMoveRequestEventArgs(AccioEvent.Quiet));
			}
			else if (e.Key == Key.RightArrow)
			{
				eventManager.Publish(new EntityMoveRequestEventArgs(AccioEvent.Quiet));
			}
			
		}*/

		private void Quit(object sender, QuitEventArgs e) 
		{
			eventManager.Publish(new QuitEventArgs());
		}

		public void Run()
		{
			try 
			{
				while (!quitFlag) 
				{
					while (Events.Poll()) 
					{
						// handle events till the queue is empty
					} 
					
					try 
					{
						eventManager.Publish(new TickEventArgs());
					} 
					catch (SurfaceLostException) 
					{
					}
				}
			} 
			catch 
			{
				throw; // for this example we'll just throw it to the debugger
			}
		}
	}
}
