using System;
using SdlDotNet;
using System.Drawing;

namespace PatrullaAguila
{
	public class SDLView
	{
		EventManager eventManager;
		int height;
		int width;
		int tamanyCella;
		int tamanyAvio;
		Surface surf;

		public SDLView (EventManager eventManager)
		{
			this.width = 640;
			this.height = 480;
			this.tamanyCella = 50;
			this.tamanyAvio = this.tamanyCella / 2;
		}

		public void CreateView()
		{
			Video.SetVideoModeWindow(this.width, this.height, true);
			this.surf = Video.Screen.CreateCompatibleSurface(width, height, true);
			//fill the surface with black
			this.surf.Fill(new Rectangle(new Point(0, 0), surf.Size), Color.Black);
			Video.WindowCaption = "Patrulla Aguila";
			Video.Mouse.ShowCursor(true);
		}

		public void ShowFormacio(TipusCoordenada[] coordenades) 
		{
			Video.Screen.Flip();
			this.surf.Fill(new Rectangle(new Point(0, 0), surf.Size), Color.Black);

			for(int i = 0; i < 7; i++)
			{
				for(int j = 0; j < 7; j++)
				{
					Box box = new Box((short)(j*tamanyCella), (short)(i*tamanyCella), (short)((j+1)*tamanyCella), (short)((i+1)*tamanyCella));
					
					this.surf.DrawBox(box, Color.White);
					Video.Screen.Blit(surf, new Rectangle(new Point(0, 0), Video.Screen.Size));
				}
			}

			for(int i = 0; i < coordenades.Length; i++) 
			{
				Circle circle = new Circle((short)((coordenades[i].y * tamanyCella) + tamanyCella/2), (short)((coordenades[i].x* tamanyCella) + tamanyCella/2), (short)tamanyAvio);
				
				switch(i) 
				{
					case 0:
						this.surf.DrawFilledCircle(circle, Color.Red);
						break;
					case 1:
						this.surf.DrawFilledCircle(circle, Color.White);
						break;
					case 2:
						this.surf.DrawFilledCircle(circle, Color.Yellow);
						break;
					case 3:
						this.surf.DrawFilledCircle(circle, Color.Green);
						break;
					case 4:
						this.surf.DrawFilledCircle(circle, Color.Blue);
						break;
					case 5:
						this.surf.DrawFilledCircle(circle, Color.Pink);
						break;
					case 6:
						this.surf.DrawFilledCircle(circle, Color.Purple);
						break;
					case 7:
						this.surf.DrawFilledCircle(circle, Color.Plum);
						break;
				}
				Video.Screen.Blit(surf, new Rectangle(new Point(0, 0), Video.Screen.Size));
			}
			Video.Screen.Flip();

		}
	}
}
